<?php
class auctionSession
{		
	private $serverUrl;
	private $soapAuction;
	
	public function __construct($serverUrl, $soapAuction)
	{
		$this->serverUrl = $serverUrl;
		$this->soapAuction = $soapAuction;	
	}
	
	/**	sendHttpRequest
		Sends a HTTP request to the server for this session
		Input:	$requestBody
		Output:	The HTTP Response as a String
	*/
	public function sendHttpRequest($requestBody)
	{		
		//build auction headers using variables passed via constructor
		$headers = $this->buildAuctionHeaders(strlen($requestBody));
				
		//initialise a CURL session
		$connection = curl_init();
		
				 
		//set the server we are using (could be Sandbox or Production server)
		curl_setopt($connection, CURLOPT_URL, $this->serverUrl);
		
		//stop CURL from verifying the peer's certificate
		curl_setopt($connection, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($connection, CURLOPT_SSL_VERIFYHOST, 0);
		
		//set the headers using the array of headers
		curl_setopt($connection, CURLOPT_HTTPHEADER, $headers);
		
		//set method as POST
		curl_setopt($connection, CURLOPT_POST, 1);
		
		//set the XML body of the request
		curl_setopt($connection, CURLOPT_POSTFIELDS, $requestBody);
		
		//set it to return the transfer as a string from curl_exec
		curl_setopt($connection, CURLOPT_RETURNTRANSFER, 1);
		
		//Send the Request
		$response = curl_exec($connection);
		
		//close the connection
		curl_close($connection);
		
		//return the response
		return $response;
	}
	
	private function buildAuctionHeaders($requestBodyLength)
	{
		$headers = array (
			"Content-Type: text/xml; charset=utf-8",
			"Content-Length: $requestBodyLength",
			"SOAPAction: $this->soapAuction"
		);
		
		return $headers;
	}
}
?>	
<?php 

 /*
 * requestCartNo
 * ǰ ϰ ߱޵ īƮȣ ûմϴ.
 * http://www.auction.co.kr/IpayService/Ipay/InsertIpayOrderToLong  
 *  ǽÿ Request SOAP Response SOAP ֽø ˴ϴ.
 *  API  Ŀ´Ƽ : http://api.auction.co.kr/developer
 */
class requestCartNo
{ 	  	 
	private $serverUrl = "https://api.auction.co.kr/ArcheSystem/IpayService.asmx";	//   ּ
	private $action = "http://www.auction.co.kr/IpayService/Ipay/InsertIpayOrderToLong";  
	private $ticket; 
	
	
	public function __construct($ticket){ 
		$this->ticket = $ticket;
	}
	
	
	/*** 񽺸 (ȣ)Ѵ.*/ 
	public function doService($orderQuery){ 
  
	// Set Request SOAP Message
	$requestXmlBody =  '<?xml version="1.0" encoding="utf-8"?>	';
	$requestXmlBody .=  '<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/"> ';
	$requestXmlBody .=  '  <soap:Header>		';
	$requestXmlBody .=  '   <EncryptedTicket xmlns="http://www.auction.co.kr/Security">		';
	$requestXmlBody .=	'   <Value>' . $this->ticket .  '</Value> ';
	$requestXmlBody .=  '		</EncryptedTicket> ';
	$requestXmlBody .=  '	</soap:Header> ';
	$requestXmlBody .=  '  <soap:Body>		';
	$requestXmlBody .=  '    <InsertIpayOrderToLong xmlns="http://www.auction.co.kr/IpayService/Ipay">';
	$requestXmlBody .=  $orderQuery; 
	$requestXmlBody .=  '</InsertIpayOrderToLong> ';
	$requestXmlBody .=  '</soap:Body> ';
	$requestXmlBody .=  '</soap:Envelope> '; 
	
			
	$requestXmlBody = str_replace("&", "&amp;", $requestXmlBody);


	// Load the XML Document to Print Request SOAP
	$requestDoc = new DomDocument();
	$requestDoc->loadXML($requestXmlBody);
	
	// Print Request SOAP 
	echo "<PRE>";
	echo "<STRONG>* REQUEST SOAP</STRONG><BR>";
	echo htmlentities ($requestDoc->saveXML());
	echo "</PRE>";
	 
	
 	//Create a new auction session with all details pulled in from included auctionSession.php
	$session = new auctionSession($this->serverUrl, $this->action);
	
	//send the request and get response
	$responseXml = $session->sendHttpRequest($requestXmlBody);
	
	// Process Response
	return $this->processResponse ($responseXml);
	}
	
	/**
	 * Request SOAP Message  ûϰ ޾ƿ Response SOAP Message  óѴ.
	 * $responseXml	: Response SOAP Message
	 */
	private function processResponse($responseXml){
		
		if(stristr($responseXml, 'HTTP 404') || $responseXml == '') {
			die('<P>Error sending request');
		} else {
			//Xml string is parsed and creates a DOM Document object
			$responseDoc = new DomDocument();
			$responseDoc->loadXML($responseXml);  
			
			
			
			// Print Response SOAP  
			echo "<PRE>";
			echo "<STRONG>* RESPONSE SOAP</STRONG><BR>";
			echo "<BR>".iconv("UTF-8", "EUC-KR", urldecode (htmlentities ($responseDoc->saveXML(), ENT_NOQUOTES, "UTF-8")) );
			echo "</PRE>";			
		  
			
			// Error 
			$eleFaultcode = $responseDoc->getElementsByTagName('faultcode')->item(0);			
			$eleFaultstring = $responseDoc->getElementsByTagName('faultstring')->item(0); 
			$eleResult =  $responseDoc->getElementsByTagName('InsertIpayOrderToLongResult')->item(0); 
			
			if ((empty($eleFaultcode)) && (!empty($eleResult)))
			{   
				return $eleResult->firstChild->nodeValue; 
			}
			else{			 
				$this->processError($eleFaultcode, $eleFaultstring);
			}			
		} 
		return "";
	}
	
	
	/**
	 *  ó Ѵ.
	 * $eleFaultcode	:  ڵ ޽
	 * $eleFaultstring	:  ޽
	 */
	private function processError($eleFaultcode, $eleFaultstring){
		if ($eleFaultcode != null) echo "faultcode : ".iconv("UTF-8", "EUC-KR", urldecode (htmlentities ($eleFaultcode->nodeValue, ENT_NOQUOTES, "UTF-8")))."<BR>";
		if ($eleFaultstring != null) echo "faultstring : ".iconv("UTF-8", "EUC-KR", urldecode (htmlentities ($eleFaultstring->nodeValue, ENT_NOQUOTES, "UTF-8")))."<BR>";
	}
}	
?>

<?php  
/*
' ǰ ۼ
*/
/*  	 
	$ticket = API Ƽ;
	$price = ǰ;
	$sellerid = ̿ ̵
*/  
$ticket =  
"d6CLKXxE0tPDLVa599qXYpWqy9v4SFWieCbJXCzIMGVL/H+0IRMdlSetMXoBhmoYWgbqv02KZsUldPhZtoaU586/RBrDMjoGUIiJoq1m7Obn6N6XJpEXtHSAwufVU8drRyheJMZm2pnebpC7vt3afvKcXR1Wj/kkIAyru3WOD7nwhwTNdTejk9OUXUL409s9Jl5de0B+fuQJehlMPaQiOb8="; 
$price = 32300;
$sellerid = "Ǹid";	

/*	ǰ xml  */
$orderQuery = "<ORDER payment_rule='0' pay_price='32300' shipping_price='2500' shipping_type='3' back_url='www.url.co.kr' service_url='wwwurl.com/receiveXml.asp' 

redirect_url='www.ebay.com' />";
$itemsQuery = "<ITEMS>";  
$itemsQuery = $itemsQuery   
	. "<IpayServiceItems item_name=" . "'Levis [źƯ] ĵƼ 2 Ŀ ĵƼ,Ƽ,̽,Ƽ'"
	. " ipay_itemno=" . "'47245950'"  . " item_option_name=" . "'ҷ[105]/free'" . " item_price='" . 29800 . "' order_qty='" . 1 . "'"  
	.	" item_url=" . "'http://www.url.com/Wxb1C47gQBWL5p2Bm4zXBILoyAG33D'"
.	" thumbnail_url=" . "'http://www.url.com/product/spec/542/30/93/5423093605.jpg'" . "/> ";   
$orderQuery = $orderQuery . $itemsQuery . "</ITEMS>"; 


$requestCartNo = new requestCartNo ($ticket);
$requestResult = $requestCartNo->doService($orderQuery);							// 񽺸 ȣϰ  īƮȣ ´
echo "CartNo = " . $requestResult; 
 
if ((!empty($requestResult)) && ($requestResult > 0))
{
?>
<html>
<body>
<form name="frm" method="get" action="https://ssl.auction.co.kr/ipay/IpayStdOrder.aspx">
<input type="hidden" name="cartnos" value="<?php echo $requestResult ?>">
<input type="hidden" name="sellerid" value="<?php echo $sellerid ?>">
<input type="hidden" name="price" value="<?php echo $price ?>">
<p align=center>
	<img name=:myImg" src="loading.gif" style="border=0"/><br />
	<b>ø ٷ ּ...</b>
</p>
</form>
<br /><br /><br /><br />
</body>
<script> 
//document.frm.target = "_top";
//document.frm.submit(); 
</script>
</html>
<?php } ?>
